using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Diagnostics;
using System.Drawing;
using System.Windows.Forms;


    static class Utils_LocaleNames
    {
        internal static string Language = "English";
        private static string[,] ls = new string[1, 0];

        internal static void SetLocales()
        {
            //  ------------------------------------- read the file
            ReadLocaleFile();
            //  ------------------------------------- rename
            RenameControls(Theremino_Dolfrang.My.MyProject.Forms.Form_Main);
            RenameControls(Theremino_Dolfrang.My.MyProject.Forms.Form_About);
            //  ------------------------------------- release the array
            Module_Utils.RedimPreserve_2D_Array(ref ls, -1, -1);
        }

        private static void ReadLocaleFile()
        {
            string LangName = Utils_LocaleNames.Language.Substring(0, 3).ToUpper().Replace("JAP", "JPN");
            string locfilename = Theremino.PlatformAdjustedFileName(Application.StartupPath + "\\Docs\\Language_" + LangName + ".txt", "");
            if (!Module_SaveLoad.FileExists(locfilename))
            {
                locfilename = Theremino.PlatformAdjustedFileName(Application.StartupPath + "\\Docs\\Language_ENG.txt", "");
            }
            if (Module_SaveLoad.FileExists(locfilename))
            {
                Int32 i = -1;
                string s0;
                string s1;
                // 
                System.IO.StreamReader f;
                f = new System.IO.StreamReader(locfilename, System.Text.Encoding.Default);
                //
                while (!f.EndOfStream)
                {
                    s1 = f.ReadLine();
                    s1 = s1.Replace('\t', ' ').Trim();
                    s0 = Module_SaveLoad.ExtractParamName(ref s1);
                    if (((s0.Length > 1) && (s1.Length > 1)))
                    {
                        if (s0.StartsWith("Msg_"))
                        {
                            AddMessage(s0, s1);
                        }
                        else
                        {
                            i++;
                            Module_Utils.RedimPreserve_2D_Array(ref ls, 1, i);
                            ls[0, i] = s0;
                            ls[1, i] = s1;
                        }
                    }
                }
                f.Close();
            }
        }

        private static void RenameControls(Control container)
        {
            // 
            for (Int32 i = 0; (i <= (ls.GetLength(1) - 1)); i++)
            {
                if ((container.Name == ls[0, i]))
                {
                    container.Text = ls[1, i];
                }
            }
            // 
            foreach (Control ctrl in container.Controls)
            {
                for (Int32 i = 0; (i <= (ls.GetLength(1) - 1)); i++)
                {
                    if ((ctrl.Name == ls[0, i]))
                    {
                        ctrl.Text = ls[1, i];
                    }
                    if (ctrl is ToolStrip)
                    {
                        ToolStrip ts = (ToolStrip)ctrl;
                        RenameToolStripItems(ref ts);
                    }
                    if (ctrl is MenuStrip)
                    {
                        MenuStrip ms = (MenuStrip)ctrl;
                        RenameMenuStripItems(ref ms);
                    }
                }
                //  ---------------------------- Recursively call this function for any container controls.
                if (container.HasChildren)
                {
                    RenameControls(ctrl);
                }
            }
        }

        private static void RenameToolStripItems(ref ToolStrip ts)
        {
            for (Int32 i = 0; (i <= (ls.GetLength(1) - 1)); i++)
            {
                for (Int32 j = 0; (j <= (ts.Items.Count - 1)); j++)
                {
                    if ((ts.Items[j].Name == ls[0, i]))
                    {
                        ts.Items[j].Text = (" " + ls[1, i]);
                    }
                }
            }
        }

        private static void RenameMenuStripItems(ref MenuStrip ms)
        {
            for (Int32 i = 0; (i <= (ls.GetLength(1) - 1)); i++)
            {
                for (Int32 j = 0; (j <= (ms.Items.Count - 1)); j++)
                {
                    if ((ms.Items[j].Name == ls[0, i]))
                    {
                        ms.Items[j].Text = (" " + ls[1, i]);
                    }
                    ToolStripMenuItem tsmi = (ToolStripMenuItem)ms.Items[j];
                    for (Int32 k = 0; (k <= (tsmi.DropDownItems.Count - 1)); k++)
                    {
                        if ((tsmi.DropDownItems[k].Name == ls[0, i]))
                        {
                            tsmi.DropDownItems[k].Text = (" " + ls[1, i]);
                        }
                    }
                }
            }
        }

       internal static string Msg_AcquInterrupted = " Acquisition manually interrupted";
       internal static string Msg_OutputFileError = "Can not write the output SAF file";
       internal static string Msg_Time = "Time (sec)";
       internal static string Msg_Samples = "Samples";
       internal static string Msg_Frequency = "Frequency (hz)";
       internal static string Msg_OperationZeroSetting = "ZERO SETTING";
       internal static string Msg_OperationAcquisition = "ACQUISITION";

        
        private static void AddMessage(string s0, string s1) {
            switch (s0) {
                case "Msg_AcquInterrupted":
                    Msg_AcquInterrupted = s1;
                    break;
                case "Msg_CanNotOpenOutputFile":
                    Msg_OutputFileError = s1;
                    break;
                case "Msg_Time":
                    Msg_Time = s1;
                    break;
                case "Msg_Samples":
                    Msg_Samples = s1;
                    break;
                case "Msg_Frequency":
                    Msg_Frequency = s1;
                    break;
                case "Msg_OperationZeroSetting":
                    Msg_OperationZeroSetting = s1;
                    break;
                case "Msg_OperationAcquisition":
                    Msg_OperationAcquisition = s1;
                    break;
            }
        }

    }


